package b4a.emailtest;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        mostCurrent = this;
		if (processBA == null) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.emailtest", "b4a.emailtest.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.setActivityPaused(true);
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(this, processBA, wl, true))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.emailtest", "b4a.emailtest.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.emailtest.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null)
            return;
        if (this != mostCurrent)
			return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
            main mc = mostCurrent;
			if (mc == null || mc != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
            if (mc != mostCurrent)
                return;
		    processBA.raiseEvent(mc._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

private static BA killProgramHelper(BA ba) {
    if (ba == null)
        return null;
    anywheresoftware.b4a.BA.SharedProcessBA sharedProcessBA = ba.sharedProcessBA;
    if (sharedProcessBA == null || sharedProcessBA.activityBA == null)
        return null;
    return sharedProcessBA.activityBA.get();
}
public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = killProgramHelper(main.mostCurrent == null ? null : main.mostCurrent.processBA);
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_create", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime}));}
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="Activity.LoadLayout(\"Layout1\")";
mostCurrent._activity.LoadLayout("Layout1",mostCurrent.activityBA);
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_resume", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null));}
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196612;
 //BA.debugLineNum = 196612;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "button1_click", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "button1_click", null));}
anywheresoftware.b4a.objects.WorkbookWrapper.WritableWorkbookWrapper _testbook1 = null;
anywheresoftware.b4a.objects.WorkbookWrapper.WritableSheetWrapper _testsheet = null;
anywheresoftware.b4a.objects.WorkbookWrapper.WritableCellWrapper _testcell = null;
anywheresoftware.b4a.keywords.StringBuilderWrapper _sb = null;
int _i = 0;
anywheresoftware.b4a.objects.WorkbookWrapper _rdbook = null;
anywheresoftware.b4a.objects.WorkbookWrapper.SheetWrapper _rdsheet = null;
RDebugUtils.currentLine=720896;
 //BA.debugLineNum = 720896;BA.debugLine="Sub Button1_Click";
RDebugUtils.currentLine=720898;
 //BA.debugLineNum = 720898;BA.debugLine="Dim Testbook1 As WritableWorkbook";
_testbook1 = new anywheresoftware.b4a.objects.WorkbookWrapper.WritableWorkbookWrapper();
RDebugUtils.currentLine=720899;
 //BA.debugLineNum = 720899;BA.debugLine="Testbook1.Initialize(File.DirRootExternal, \"xl1.x";
_testbook1.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"xl1.xlsx");
RDebugUtils.currentLine=720901;
 //BA.debugLineNum = 720901;BA.debugLine="Dim TestSheet As WritableSheet";
_testsheet = new anywheresoftware.b4a.objects.WorkbookWrapper.WritableSheetWrapper();
RDebugUtils.currentLine=720902;
 //BA.debugLineNum = 720902;BA.debugLine="TestSheet = Testbook1.AddSheet(\"Test\", 0)";
_testsheet = _testbook1.AddSheet("Test",(int) (0));
RDebugUtils.currentLine=720904;
 //BA.debugLineNum = 720904;BA.debugLine="Dim TestCell As WritableCell";
_testcell = new anywheresoftware.b4a.objects.WorkbookWrapper.WritableCellWrapper();
RDebugUtils.currentLine=720907;
 //BA.debugLineNum = 720907;BA.debugLine="TestCell.InitializeNumber(6, 0, -10000)";
_testcell.InitializeNumber((int) (6),(int) (0),-10000);
RDebugUtils.currentLine=720908;
 //BA.debugLineNum = 720908;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720909;
 //BA.debugLineNum = 720909;BA.debugLine="TestCell.InitializeNumber(6, 1, 2000)";
_testcell.InitializeNumber((int) (6),(int) (1),2000);
RDebugUtils.currentLine=720910;
 //BA.debugLineNum = 720910;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720911;
 //BA.debugLineNum = 720911;BA.debugLine="TestCell.InitializeNumber(6, 2, 3000)";
_testcell.InitializeNumber((int) (6),(int) (2),3000);
RDebugUtils.currentLine=720912;
 //BA.debugLineNum = 720912;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720913;
 //BA.debugLineNum = 720913;BA.debugLine="TestCell.InitializeNumber(6, 3, 4000)";
_testcell.InitializeNumber((int) (6),(int) (3),4000);
RDebugUtils.currentLine=720914;
 //BA.debugLineNum = 720914;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720915;
 //BA.debugLineNum = 720915;BA.debugLine="TestCell.InitializeNumber(6, 4, 5000)";
_testcell.InitializeNumber((int) (6),(int) (4),5000);
RDebugUtils.currentLine=720916;
 //BA.debugLineNum = 720916;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720920;
 //BA.debugLineNum = 720920;BA.debugLine="Dim sb As StringBuilder";
_sb = new anywheresoftware.b4a.keywords.StringBuilderWrapper();
RDebugUtils.currentLine=720921;
 //BA.debugLineNum = 720921;BA.debugLine="sb.Initialize";
_sb.Initialize();
RDebugUtils.currentLine=720923;
 //BA.debugLineNum = 720923;BA.debugLine="sb.Append(\"SUM(\")";
_sb.Append("SUM(");
RDebugUtils.currentLine=720924;
 //BA.debugLineNum = 720924;BA.debugLine="For i = 1 To 5";
{
final int step19 = 1;
final int limit19 = (int) (5);
_i = (int) (1) ;
for (;_i <= limit19 ;_i = _i + step19 ) {
RDebugUtils.currentLine=720925;
 //BA.debugLineNum = 720925;BA.debugLine="If i > 1 Then sb.Append(\",\")";
if (_i>1) { 
_sb.Append(",");};
RDebugUtils.currentLine=720926;
 //BA.debugLineNum = 720926;BA.debugLine="sb.Append(\"Test!G\").Append(i)";
_sb.Append("Test!G").Append(BA.NumberToString(_i));
 }
};
RDebugUtils.currentLine=720928;
 //BA.debugLineNum = 720928;BA.debugLine="sb.Append(\")\")";
_sb.Append(")");
RDebugUtils.currentLine=720929;
 //BA.debugLineNum = 720929;BA.debugLine="TestCell.InitializeFormula(7, 5, sb.ToString)";
_testcell.InitializeFormula((int) (7),(int) (5),_sb.ToString());
RDebugUtils.currentLine=720930;
 //BA.debugLineNum = 720930;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720933;
 //BA.debugLineNum = 720933;BA.debugLine="sb.Append(\"SUM(G1:G5)\")";
_sb.Append("SUM(G1:G5)");
RDebugUtils.currentLine=720934;
 //BA.debugLineNum = 720934;BA.debugLine="TestCell.InitializeFormula(8, 5, sb.ToString)";
_testcell.InitializeFormula((int) (8),(int) (5),_sb.ToString());
RDebugUtils.currentLine=720935;
 //BA.debugLineNum = 720935;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720937;
 //BA.debugLineNum = 720937;BA.debugLine="sb.Append(\"COUNT(\")";
_sb.Append("COUNT(");
RDebugUtils.currentLine=720938;
 //BA.debugLineNum = 720938;BA.debugLine="For i = 1 To 5";
{
final int step30 = 1;
final int limit30 = (int) (5);
_i = (int) (1) ;
for (;_i <= limit30 ;_i = _i + step30 ) {
RDebugUtils.currentLine=720939;
 //BA.debugLineNum = 720939;BA.debugLine="If i > 1 Then sb.Append(\",\")";
if (_i>1) { 
_sb.Append(",");};
RDebugUtils.currentLine=720940;
 //BA.debugLineNum = 720940;BA.debugLine="sb.Append(\"Test!G\").Append(i)";
_sb.Append("Test!G").Append(BA.NumberToString(_i));
 }
};
RDebugUtils.currentLine=720942;
 //BA.debugLineNum = 720942;BA.debugLine="sb.Append(\")\")";
_sb.Append(")");
RDebugUtils.currentLine=720943;
 //BA.debugLineNum = 720943;BA.debugLine="TestCell.InitializeFormula(7, 7, sb.ToString)";
_testcell.InitializeFormula((int) (7),(int) (7),_sb.ToString());
RDebugUtils.currentLine=720944;
 //BA.debugLineNum = 720944;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720946;
 //BA.debugLineNum = 720946;BA.debugLine="Log(sb.ToString)";
anywheresoftware.b4a.keywords.Common.LogImpl("0720946",_sb.ToString(),0);
RDebugUtils.currentLine=720948;
 //BA.debugLineNum = 720948;BA.debugLine="sb.Append(\"COUNT(G1:G5)\")";
_sb.Append("COUNT(G1:G5)");
RDebugUtils.currentLine=720949;
 //BA.debugLineNum = 720949;BA.debugLine="TestCell.InitializeFormula(8, 7, sb.ToString)";
_testcell.InitializeFormula((int) (8),(int) (7),_sb.ToString());
RDebugUtils.currentLine=720950;
 //BA.debugLineNum = 720950;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720952;
 //BA.debugLineNum = 720952;BA.debugLine="Log(sb.ToString)";
anywheresoftware.b4a.keywords.Common.LogImpl("0720952",_sb.ToString(),0);
RDebugUtils.currentLine=720954;
 //BA.debugLineNum = 720954;BA.debugLine="sb.Append(\"AVERAGE(\")";
_sb.Append("AVERAGE(");
RDebugUtils.currentLine=720955;
 //BA.debugLineNum = 720955;BA.debugLine="For i = 1 To 5";
{
final int step43 = 1;
final int limit43 = (int) (5);
_i = (int) (1) ;
for (;_i <= limit43 ;_i = _i + step43 ) {
RDebugUtils.currentLine=720956;
 //BA.debugLineNum = 720956;BA.debugLine="If i > 1 Then sb.Append(\",\")";
if (_i>1) { 
_sb.Append(",");};
RDebugUtils.currentLine=720957;
 //BA.debugLineNum = 720957;BA.debugLine="sb.Append(\"Test!G\").Append(i)";
_sb.Append("Test!G").Append(BA.NumberToString(_i));
 }
};
RDebugUtils.currentLine=720959;
 //BA.debugLineNum = 720959;BA.debugLine="sb.Append(\")\")";
_sb.Append(")");
RDebugUtils.currentLine=720960;
 //BA.debugLineNum = 720960;BA.debugLine="TestCell.InitializeFormula(7, 8, sb.ToString)";
_testcell.InitializeFormula((int) (7),(int) (8),_sb.ToString());
RDebugUtils.currentLine=720961;
 //BA.debugLineNum = 720961;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720963;
 //BA.debugLineNum = 720963;BA.debugLine="Log(sb.ToString)";
anywheresoftware.b4a.keywords.Common.LogImpl("0720963",_sb.ToString(),0);
RDebugUtils.currentLine=720965;
 //BA.debugLineNum = 720965;BA.debugLine="sb.Append(\"AVERAGE(G1:G5)\")";
_sb.Append("AVERAGE(G1:G5)");
RDebugUtils.currentLine=720966;
 //BA.debugLineNum = 720966;BA.debugLine="TestCell.InitializeFormula(8, 8, sb.ToString)";
_testcell.InitializeFormula((int) (8),(int) (8),_sb.ToString());
RDebugUtils.currentLine=720967;
 //BA.debugLineNum = 720967;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720969;
 //BA.debugLineNum = 720969;BA.debugLine="Log(sb.ToString)";
anywheresoftware.b4a.keywords.Common.LogImpl("0720969",_sb.ToString(),0);
RDebugUtils.currentLine=720971;
 //BA.debugLineNum = 720971;BA.debugLine="sb.Append(\"MAX(\")";
_sb.Append("MAX(");
RDebugUtils.currentLine=720972;
 //BA.debugLineNum = 720972;BA.debugLine="For i = 1 To 5";
{
final int step56 = 1;
final int limit56 = (int) (5);
_i = (int) (1) ;
for (;_i <= limit56 ;_i = _i + step56 ) {
RDebugUtils.currentLine=720973;
 //BA.debugLineNum = 720973;BA.debugLine="If i > 1 Then sb.Append(\",\")";
if (_i>1) { 
_sb.Append(",");};
RDebugUtils.currentLine=720974;
 //BA.debugLineNum = 720974;BA.debugLine="sb.Append(\"Test!G\").Append(i)";
_sb.Append("Test!G").Append(BA.NumberToString(_i));
 }
};
RDebugUtils.currentLine=720976;
 //BA.debugLineNum = 720976;BA.debugLine="sb.Append(\")\")";
_sb.Append(")");
RDebugUtils.currentLine=720977;
 //BA.debugLineNum = 720977;BA.debugLine="TestCell.InitializeFormula(7, 9, sb.ToString)";
_testcell.InitializeFormula((int) (7),(int) (9),_sb.ToString());
RDebugUtils.currentLine=720978;
 //BA.debugLineNum = 720978;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720980;
 //BA.debugLineNum = 720980;BA.debugLine="Log(sb.ToString)";
anywheresoftware.b4a.keywords.Common.LogImpl("0720980",_sb.ToString(),0);
RDebugUtils.currentLine=720982;
 //BA.debugLineNum = 720982;BA.debugLine="sb.Append(\"MAX(G1:G5)\")";
_sb.Append("MAX(G1:G5)");
RDebugUtils.currentLine=720983;
 //BA.debugLineNum = 720983;BA.debugLine="TestCell.InitializeFormula(8, 9, sb.ToString)";
_testcell.InitializeFormula((int) (8),(int) (9),_sb.ToString());
RDebugUtils.currentLine=720984;
 //BA.debugLineNum = 720984;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720986;
 //BA.debugLineNum = 720986;BA.debugLine="Log(sb.ToString)";
anywheresoftware.b4a.keywords.Common.LogImpl("0720986",_sb.ToString(),0);
RDebugUtils.currentLine=720988;
 //BA.debugLineNum = 720988;BA.debugLine="sb.Append(\"IRR(\")";
_sb.Append("IRR(");
RDebugUtils.currentLine=720989;
 //BA.debugLineNum = 720989;BA.debugLine="For i = 1 To 5";
{
final int step69 = 1;
final int limit69 = (int) (5);
_i = (int) (1) ;
for (;_i <= limit69 ;_i = _i + step69 ) {
RDebugUtils.currentLine=720990;
 //BA.debugLineNum = 720990;BA.debugLine="If i > 1 Then sb.Append(\",\")";
if (_i>1) { 
_sb.Append(",");};
RDebugUtils.currentLine=720991;
 //BA.debugLineNum = 720991;BA.debugLine="sb.Append(\"Test!G\").Append(i)";
_sb.Append("Test!G").Append(BA.NumberToString(_i));
 }
};
RDebugUtils.currentLine=720993;
 //BA.debugLineNum = 720993;BA.debugLine="sb.Append(\")\")";
_sb.Append(")");
RDebugUtils.currentLine=720994;
 //BA.debugLineNum = 720994;BA.debugLine="TestCell.InitializeFormula(7, 10, sb.ToString)";
_testcell.InitializeFormula((int) (7),(int) (10),_sb.ToString());
RDebugUtils.currentLine=720995;
 //BA.debugLineNum = 720995;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=720997;
 //BA.debugLineNum = 720997;BA.debugLine="Log(sb.ToString)";
anywheresoftware.b4a.keywords.Common.LogImpl("0720997",_sb.ToString(),0);
RDebugUtils.currentLine=720999;
 //BA.debugLineNum = 720999;BA.debugLine="sb.Append(\"=IRR(G1:G5)\")";
_sb.Append("=IRR(G1:G5)");
RDebugUtils.currentLine=721000;
 //BA.debugLineNum = 721000;BA.debugLine="TestCell.InitializeFormula(8, 10, sb.ToString)";
_testcell.InitializeFormula((int) (8),(int) (10),_sb.ToString());
RDebugUtils.currentLine=721001;
 //BA.debugLineNum = 721001;BA.debugLine="TestSheet.AddCell(TestCell)";
_testsheet.AddCell((jxl.write.WritableCell)(_testcell.getObject()));
RDebugUtils.currentLine=721009;
 //BA.debugLineNum = 721009;BA.debugLine="Testbook1.Write";
_testbook1.Write();
RDebugUtils.currentLine=721010;
 //BA.debugLineNum = 721010;BA.debugLine="Testbook1.Close";
_testbook1.Close();
RDebugUtils.currentLine=721012;
 //BA.debugLineNum = 721012;BA.debugLine="Dim rdbook As ReadableWorkbook";
_rdbook = new anywheresoftware.b4a.objects.WorkbookWrapper();
RDebugUtils.currentLine=721013;
 //BA.debugLineNum = 721013;BA.debugLine="Dim rdsheet As ReadableSheet";
_rdsheet = new anywheresoftware.b4a.objects.WorkbookWrapper.SheetWrapper();
RDebugUtils.currentLine=721015;
 //BA.debugLineNum = 721015;BA.debugLine="rdbook.Initialize(File.DirRootExternal, \"xl1.xlsx";
_rdbook.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"xl1.xlsx");
RDebugUtils.currentLine=721016;
 //BA.debugLineNum = 721016;BA.debugLine="rdsheet = rdbook.GetSheet(0)";
_rdsheet = _rdbook.GetSheet((int) (0));
RDebugUtils.currentLine=721018;
 //BA.debugLineNum = 721018;BA.debugLine="For i = 0 To 4";
{
final int step86 = 1;
final int limit86 = (int) (4);
_i = (int) (0) ;
for (;_i <= limit86 ;_i = _i + step86 ) {
RDebugUtils.currentLine=721019;
 //BA.debugLineNum = 721019;BA.debugLine="Log(rdsheet.GetCellValue(6,i))";
anywheresoftware.b4a.keywords.Common.LogImpl("0721019",_rdsheet.GetCellValue((int) (6),_i),0);
 }
};
RDebugUtils.currentLine=721022;
 //BA.debugLineNum = 721022;BA.debugLine="Log(\"SUM = \" & rdsheet.GetCellValue(7,5))";
anywheresoftware.b4a.keywords.Common.LogImpl("0721022","SUM = "+_rdsheet.GetCellValue((int) (7),(int) (5)),0);
RDebugUtils.currentLine=721023;
 //BA.debugLineNum = 721023;BA.debugLine="Log(\"COUNT = \" & rdsheet.GetCellValue(8,8))";
anywheresoftware.b4a.keywords.Common.LogImpl("0721023","COUNT = "+_rdsheet.GetCellValue((int) (8),(int) (8)),0);
RDebugUtils.currentLine=721024;
 //BA.debugLineNum = 721024;BA.debugLine="Log(\"AVERAGE = \" & rdsheet.GetCellValue(8,9))";
anywheresoftware.b4a.keywords.Common.LogImpl("0721024","AVERAGE = "+_rdsheet.GetCellValue((int) (8),(int) (9)),0);
RDebugUtils.currentLine=721025;
 //BA.debugLineNum = 721025;BA.debugLine="Log(\"MAX = \" & rdsheet.GetCellValue(8,10))";
anywheresoftware.b4a.keywords.Common.LogImpl("0721025","MAX = "+_rdsheet.GetCellValue((int) (8),(int) (10)),0);
RDebugUtils.currentLine=721027;
 //BA.debugLineNum = 721027;BA.debugLine="rdbook.Close";
_rdbook.Close();
RDebugUtils.currentLine=721029;
 //BA.debugLineNum = 721029;BA.debugLine="Msgbox(\"Process over\",\"\")";
anywheresoftware.b4a.keywords.Common.Msgbox(BA.ObjectToCharSequence("Process over"),BA.ObjectToCharSequence(""),mostCurrent.activityBA);
RDebugUtils.currentLine=721031;
 //BA.debugLineNum = 721031;BA.debugLine="End Sub";
return "";
}
}